--     Island Explorer - An AIO island expeditions assistant
--     Copyright (C) 2019  Nivix
-- 
--     This program is free software: you can redistribute it and/or modify
--     it under the terms of the GNU General Public License as published by
--     the Free Software Foundation, either version 3 of the License, or
--     (at your option) any later version.
-- 
--     This program is distributed in the hope that it will be useful,
--     but WITHOUT ANY WARRANTY; without even the implied warranty of
--     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--     GNU General Public License for more details.
-- 
--     You should have received a copy of the GNU General Public License
--     along with this program.  If not, see <https://www.gnu.org/licenses/>.

local IE = IslandExplorer;
local charmTracker = IE.charmTracker;

function charmTracker:buffUpdate(unitID)
	local buffInfo = {AuraUtil.FindAuraByName((GetSpellInfo(280065)), unitID)};
	if buffInfo[1] ~= nil then
        IslandExplorerFrame.scoreboard[unitID].score:SetTextColor(0.25, 0.78, 0.92);
	else
        IslandExplorerFrame.scoreboard[unitID].score:SetTextColor(1, 1, 1);
    end
    if unitID == "player" then
        if buffInfo[1] ~= nil or charmTracker.count == 0 then
            charmTracker.button:Disable();
        else
            charmTracker.button:Enable();
        end
	end	
end

function charmTracker:countUpdate()
	local count = GetItemCount((GetItemInfo(163759)));
	if count ~= charmTracker.count then
		charmTracker.count = count;
		charmTracker.button:SetText("Charm (" .. count .. ")");
	end
    charmTracker:buffUpdate("player");
end

function charmTracker:init()
    charmTracker.button = IE.frame.charmButton;
	charmTracker.button:SetAttribute("type", "item");
    local item = Item:CreateFromItemID(163759);
    item:ContinueOnItemLoad(function()
                            charmTracker.button:SetAttribute("item", (GetItemInfo(163759)));
                           end);
    charmTracker:countUpdate();
end

