--     Island Explorer - An AIO island expeditions assistant
--     Copyright (C) 2019  Nivix
-- 
--     This program is free software: you can redistribute it and/or modify
--     it under the terms of the GNU General Public License as published by
--     the Free Software Foundation, either version 3 of the License, or
--     (at your option) any later version.
-- 
--     This program is distributed in the hope that it will be useful,
--     but WITHOUT ANY WARRANTY; without even the implied warranty of
--     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--     GNU General Public License for more details.
-- 
--     You should have received a copy of the GNU General Public License
--     along with this program.  If not, see <https://www.gnu.org/licenses/>.

local IE = IslandExplorer;
local events = IE.events;

function events:ZONE_CHANGED_NEW_AREA(...)
    IE.islands.currentZone = C_Map.GetBestMapForUnit("player");
	if IE.islands.data[IE.islands.currentZone] ~= nil then
		IE.islands:onEnter();
	else
		IE.islands:onLeave();
	end
end

function events:ISLAND_AZERITE_GAIN(amount, gainedByPlayer, factionIndex, gainedBy, gainedFrom, ...)
	IE.scoreboard:update(gainedBy, amount);
end

function events:UNIT_AURA(unitID ,...)
    IE.islands:checkForStart();
    if unitID=="player" or unitID=="party1" or unitID=="party2" then
        IE.charmTracker:buffUpdate(unitID);
    end
end

function events:ISLAND_COMPLETED(...)
	IE.islands:onFinish();
end

function events:BAG_UPDATE(...)
	IE.charmTracker:countUpdate();
end

function events:ADDON_LOADED(addonName, ...)
    if addonName =="IslandExplorer" then 
        IE.islands:init();
        IE.options:init();
        events:ZONE_CHANGED_NEW_AREA();
    end
end

local function reward_callback(idx)
    return GetLFGCompletionRewardItemLink(idx);
end
function events:LFG_COMPLETION_REWARD(...)
    if IslandExplorerOptions["loot"] then
        local lfgcr = {GetLFGCompletionReward()};
        local continuableContainer = ContinuableContainer:Create();
        for idx = 1, lfgcr[10] do
            local itemInfo = {GetLFGCompletionRewardItem(idx)};
            if itemInfo[8] == "item" then
                local item = Item:CreateFromItemID(itemInfo[7]);
                continuableContainer:AddContinuable(item);
            end
        end
        continuableContainer:ContinueOnLoad(function()
                                                for idx = 1, lfgcr[10] do
                                                    local itemInfo = {GetLFGCompletionRewardItem(idx)};
                                                    if itemInfo[8] == "item" then
                                                        SendChatMessage(GetLFGCompletionRewardItemLink(idx), "PARTY");
                                                    end
                                                end
                                            end
                                            );
    end

end
function events:handler(event, ...)
	events[event](self, ...);
end

function events:init()
	IE.frame:SetScript("OnEvent", events.handler);
end
