--     Island Explorer - An AIO island expeditions assistant
--     Copyright (C) 2019  Nivix
-- 
--     This program is free software: you can redistribute it and/or modify
--     it under the terms of the GNU General Public License as published by
--     the Free Software Foundation, either version 3 of the License, or
--     (at your option) any later version.
-- 
--     This program is distributed in the hope that it will be useful,
--     but WITHOUT ANY WARRANTY; without even the implied warranty of
--     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--     GNU General Public License for more details.
-- 
--     You should have received a copy of the GNU General Public License
--     along with this program.  If not, see <https://www.gnu.org/licenses/>.

local IE = IslandExplorer;
local options = IE.options;

SLASH_ISLANDEXPLORER1 = "/islex"
SlashCmdList["ISLANDEXPLORER"] = function(msg, editbox)
    if msg == "" then
        print("IslandExplorer: \"/islex help\" to show options command list.");
        IslandExplorer.frame:Show();
        IslandExplorerOptions["show"] = true;
    elseif msg == "help" then
        print("Island Explorer command list");
        print("/islex : Show window.");
        print("/islex loot : Toggle automatic loot linking (" .. tostring(IslandExplorerOptions["loot"]) .. ").");
        print("/islex report : Toggle automatic scores reporting (" .. tostring(IslandExplorerOptions["report"]) .. ").");
    elseif msg =="loot" then
        IslandExplorerOptions["loot"] = not IslandExplorerOptions["loot"]
        if IslandExplorerOptions["loot"] then
            print("IslandExplorer will now link loot automatically.");
        else
            print("IslandExplorer will no longer link loot automatically.");
        end
    elseif msg =="report" then
        IslandExplorerOptions["report"] = not IslandExplorerOptions["report"]
        if IslandExplorerOptions["report"] then
            print("IslandExplorer will now report scores automatically.");
        else
            print("IslandExplorer will no longer report scores automatically.");
        end
    end
end

function options:hide()
    IE.frame:Hide();
    IslandExplorerOptions["show"] = false;
end

function options:init()
    if IslandExplorerOptions == nil then
        IslandExplorerOptions = { };
    end
    if IslandExplorerOptions["report"] == nil then
        IslandExplorerOptions["loot"] = true;
    end
    if IslandExplorerOptions["loot"] == nil then
        IslandExplorerOptions["loot"] = true;
    end
    if IslandExplorerOptions["show"] == nil then
        IslandExplorerOptions["show"] = false;
    end
    if IslandExplorerOptions["show"] == false then
        IE.frame:Hide();
    end
    IE.frame.CloseButton:SetScript("OnClick", options.hide);
end
