--     Island Explorer - An AIO island expeditions assistant
--     Copyright (C) 2019  Nivix
-- 
--     This program is free software: you can redistribute it and/or modify
--     it under the terms of the GNU General Public License as published by
--     the Free Software Foundation, either version 3 of the License, or
--     (at your option) any later version.
-- 
--     This program is distributed in the hope that it will be useful,
--     but WITHOUT ANY WARRANTY; without even the implied warranty of
--     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--     GNU General Public License for more details.
-- 
--     You should have received a copy of the GNU General Public License
--     along with this program.  If not, see <https://www.gnu.org/licenses/>.

local IE = IslandExplorer;
local timer = IE.timer;

function timer:toString()
	return timer.minutes .. "m" .. timer.seconds .. "s";
end

function timer:draw()
    timer.string:SetText("Time: " .. timer:toString());
end

function timer:reset()
	timer.minutes = 0;
	timer.seconds = 0;
    timer:draw();
end

function timer:start()
	timer.frame:Show();
end

function timer:stop()
	timer.frame:Hide();
end

function timer:update(elapsed)
	timer.timeSinceUpdate = timer.timeSinceUpdate + elapsed;
	while (timer.timeSinceUpdate > timer.updateInterval) do	
		timer.seconds = timer.seconds + 1;
		if timer.seconds == 60 then
			timer.seconds = 0;
			timer.minutes = timer.minutes + 1;
		end
		timer.timeSinceUpdate = timer.timeSinceUpdate - timer.updateInterval;
        timer:draw();
	end
end

function timer:init()
    timer.updateInterval = 1.0;
    timer.minutes = 0;
    timer.seconds = 0;
    timer.timeSinceUpdate = 0;
    timer.frame = IslandExplorerFrame.timer.toggle;
    timer.string = IslandExplorerFrame.timer.string;
	timer.frame:SetScript("OnUpdate", timer.update);
	timer.frame:Hide();
    timer:draw();
end

